-- Main.lua
-- Originally written by Rod, Almagnus1, extended by Habna

import "HabnaPlugins.HugeBag";
import "HabnaPlugins.HugeBag.frmMain";

write = Turbine.Shell.WriteLine;

-- List of lua file to show at startup
frmMain = frmMain(); --frmMain.lua

Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, false );
Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, false );

HugeBagCommand = Turbine.ShellCommand();

function HugeBagCommand:Execute( command, arguments )
	if ( arguments == "show" ) then
		ShowHugeBag()
	elseif ( arguments == "hide" ) then
		HideHugeBag()
	elseif ( arguments == "version" ) then
		VersionInfo()
	elseif ( arguments == "author" or arguments == "authors" ) then
		AuthorsInfo()
	elseif ( arguments == "about" ) then
		import "HabnaPlugins.HugeBag.frmAbout"; -- LUA frmAbout file
		frmAbout()
	elseif ( arguments == "resetall" ) then
		ResetSettings()
	elseif ( arguments == "resetls" ) then
		ResetLSSettings()
	elseif ( arguments == "help" or arguments == "?") then
		HelpInfo()
	elseif ( arguments == "slotsinfo" ) then
		SlotsInfo()
	elseif ( arguments == "unload" ) then
		UnloadHugeBag()
	elseif ( arguments == "reload" ) then
		ReloadHugeBag()
	elseif ( arguments == "locksize" ) then
		LockHugeBagSize()
	elseif ( arguments == "lockpos" or arguments == "lockposition") then
		LockHugeBagPosition()
	elseif ( arguments == "toggleshow" ) then
		ToggleShow()
	elseif ( arguments == "toggleslots" ) then
		ToggleSlotsInfo()
	elseif ( arguments == "toggleused" ) then
		ToggleFreeUsed()
	elseif ( arguments == "togglewesc" ) then
		ToggleWEsc()
	elseif ( arguments == "curopt" ) then
		ShowCurrentSettings()
	else
		write( "HugeBag: Command not supported" );
	end
end

Turbine.Shell.AddCommand( "HugeBag", HugeBagCommand );

if ( StartVisible ) then
	write( "HugeBag v" .. Version .. " by Habna: I'm loaded" );
else
	Turbine.Shell.WriteLine( "HugeBag v" .. Version .. " by Habna: I'm loaded BUT NOT visible" );
end

if ( ShowSlotsInfo ) then
	SlotsInfo()
end

Turbine.Plugin.Unload = function( self, sender, args )
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, true );
	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, true );
end