-- frmSettings.lua
-- written by Habna

--v IMPORT SECTION v--

--^ IMPORT SECTION ^--
--v GLOBAL VARIABLE SECTION v--
InitXPos, InitYPos = 17,33; --> ** Initial X & Y position of the first Item in the HugeBag **
edgePadding = 15; --> ** HugeBag initial edgePadding value **
Version = "1.0.4"; --> ** HugeBag current version **
StartVisible = true; --> ** Initial value to determine if HugeBag start visible or not **
ShowSlotsInfo = true; --> ** Initial value to determine if slots informations are shown are not in title **
ToggleUsed = false; --> ** Initial value to determine if free slots info are shown in title if true used slots info will be shown **
WinWidth, WinHeight = 460,300; --> ** HugeBag initial size **
WinLocX, WinLocY = self, self; --> ** HugeBag initial location **
LockPosition, LockSize = false, false; --> ** Initial value to determine if position and size are lock by default
LockLabel = self; --> ** Label that prevents from moving the window cause it's located at top
HideWEsc = false; --> ** Initial value to determine if HugeBag hide when 'esc' key is press **
DefaultOpacity = 1; --> ** Initial opacity **
OptionNameList = {};
ShellCommandName, ShellCommandDes = {}, {};
write = Turbine.Shell.WriteLine;
--^ GLOBAL VARIABLE SECTION ^--

function frmSettings()
	green = Turbine.UI.Color( 0, 0.77, 0 );
	white = Turbine.UI.Color( 1, 1, 1 );
	gray = Turbine.UI.Color( 0.5, 0.5, 0.5 );
	lightgray = Turbine.UI.Color(0.5, 0.3, 0.3, 0.3);
	black = Turbine.UI.Color()

	self = Turbine.UI.Lotro.Window()
	--self = Turbine.UI.Lotro.GoldWindow()
	
	-- **v Set backcolor, position, size and text of the window v**
	self:SetSize( 350, 320 );
	--local screenWidth, screenHeight = Turbine.UI.Display.GetSize()
	--local winWidth, winHeight = self:GetSize();
	--local left, top = ( screenWidth / 2 ) - ( winWidth / 2 ) , ( screenHeight / 2 ) - ( winHeight /2 )
    --self:SetPosition( left, top );
	self:SetPosition( WinLocX, WinLocY );
	self:SetText( "HugeBag Options" );
	self:SetBackColor( Turbine.UI.Color() )
	self:SetVisible( true );
	self:SetZOrder(1000)
	-- **^
	-- **v To create a new button v**
	local buttonClose = Turbine.UI.Lotro.Button();
	buttonClose:SetParent( self );
	buttonClose:SetPosition( 245, 287 );
	--buttonClose:SetSize( 75, 150 );
	buttonClose:SetWidth( 75 );
	buttonClose:SetText( "Close" );
	buttonClose:SetVisible( true );
	-- **^
	LoadListOptionsName()
	--**v Q Label v**
	local PosY = 40;
	for i = 1, 6 do
		local label1q = Turbine.UI.Label();
		label1q:SetParent( self );
		label1q:SetText( OptionNameList[i] );
		label1q:SetPosition( 15, PosY );
		label1q:SetSize( self:GetWidth(), 18 );
		label1q:SetForeColor( white );
		label1q:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		PosY = PosY + 20;
	end
	--**^
	--**v Show slots info in title v**
	local OptR1lbl = Turbine.UI.Label();
	OptR1lbl:SetParent( self );
	OptR1lbl:SetText( tostring( ShowSlotsInfo ) );
	OptR1lbl:SetPosition( 200, 40 );
	OptR1lbl:SetSize(35, 18 );
	OptR1lbl:SetForeColor( green );
	OptR1lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Slots info to show in title v**
	local OptR2lbl = Turbine.UI.Label();
	OptR2lbl:SetParent( self );
	if ToggleUsed then
		OptR2lbl:SetText( "used slots info" );
	else
		OptR2lbl:SetText( "free slots info" );
	end
	OptR2lbl:SetPosition( 220, 60 );
	OptR2lbl:SetSize(110, 18 );
	OptR2lbl:SetForeColor( green );
	OptR2lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Start visible at startup v**
	local OptR3lbl = Turbine.UI.Label();
	OptR3lbl:SetParent( self );
	OptR3lbl:SetText( tostring( StartVisible ) );
	OptR3lbl:SetPosition( 200, 80 );
	OptR3lbl:SetSize(35, 18 );
	OptR3lbl:SetForeColor( green );
	OptR3lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Hide HugeBag when 'esc' key is press v**
	local OptR4lbl = Turbine.UI.Label();
	OptR4lbl:SetParent( self );
	OptR4lbl:SetText( tostring( HideWEsc ) );
	OptR4lbl:SetPosition( 285, 100 );
	OptR4lbl:SetSize(35, 18 );
	OptR4lbl:SetForeColor( green );
	OptR4lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Size locker activated v**
	local OptR5lbl = Turbine.UI.Label();
	OptR5lbl:SetParent( self );
	OptR5lbl:SetText( tostring( LockSize ) );
	OptR5lbl:SetPosition( 175, 120 );
	OptR5lbl:SetSize(35, 18 );
	OptR5lbl:SetForeColor( green );
	OptR5lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Position locker activated v**
	local OptR6lbl = Turbine.UI.Label();
	OptR6lbl:SetParent( self );
	OptR6lbl:SetText( tostring( LockPosition ) );
	OptR6lbl:SetPosition( 205, 140 );
	OptR6lbl:SetSize(35, 18 );
	OptR6lbl:SetForeColor( green );
	OptR6lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Line v**
	local lblline1 = Turbine.UI.Label();
	lblline1:SetParent( self );
	lblline1:SetText( "----------------------------------------------" );
	lblline1:SetPosition( 15, 160 );
	lblline1:SetSize(self:GetWidth(), 18 );
	lblline1:SetForeColor( gray );
	lblline1:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Show free, used and max slots in shell v**
	local OptR7lbl = Turbine.UI.Label();
	OptR7lbl:SetParent( self );
	OptR7lbl:SetText( "Show Free, Used and Max slots in shell" );
	OptR7lbl:SetPosition( 15, 180 );
	OptR7lbl:SetSize(275, 18 );
	OptR7lbl:SetForeColor( green );
	OptR7lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Show free, used and max slots in shell v**
	local OptR8lbl = Turbine.UI.Label();
	OptR8lbl:SetParent( self );
	OptR8lbl:SetText( "Show HugeBag shell commands" );
	OptR8lbl:SetPosition( 15, 200 );
	OptR8lbl:SetSize(195, 18 );
	OptR8lbl:SetForeColor( green );
	OptR8lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Reset Location and size settings to default v**
	local OptR9lbl = Turbine.UI.Label();
	OptR9lbl:SetParent( self );
	OptR9lbl:SetText( "Reset Location and size settings to default" );
	OptR9lbl:SetPosition( 15, 220 );
	OptR9lbl:SetSize(310, 18 );
	OptR9lbl:SetForeColor( green );
	OptR9lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Reset all settings to default v**
	local OptR10lbl = Turbine.UI.Label();
	OptR10lbl:SetParent( self );
	OptR10lbl:SetText( "Reset all settings to default" );
	OptR10lbl:SetPosition( 15, 240 );
	OptR10lbl:SetSize(210, 18 );
	OptR10lbl:SetForeColor( green );
	OptR10lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Line v**
	local lblline2 = Turbine.UI.Label();
	lblline2:SetParent( self );
	lblline2:SetText( "----------------------------------------------" );
	lblline2:SetPosition( 15, 260 );
	lblline2:SetSize(self:GetWidth(), 18 );
	lblline2:SetForeColor( gray );
	lblline2:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--**v Reset all settings to default v**
	local OptR11lbl = Turbine.UI.Label();
	OptR11lbl:SetParent( self );
	OptR11lbl:SetText( "About HugeBag" );
	OptR11lbl:SetPosition( 15, 280 );
	OptR11lbl:SetSize(95, 18 );
	OptR11lbl:SetForeColor( green );
	OptR11lbl:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	--**^
	--^ SETTINGS SECTION ^--
	--v EVENT HANDLERS SECTION v--
	-- **v Label click event v**
	OptR1lbl.MouseClick = function(sender, args)
		ToggleSlotsInfo()
		OptR1lbl:SetText( tostring( ShowSlotsInfo ) );
	end
	OptR2lbl.MouseClick = function(sender, args)
		ToggleFreeUsed()
		if ToggleUsed then
			OptR2lbl:SetText( "used slots info" );
		else
			OptR2lbl:SetText( "free slots info" );
		end
	end
	OptR3lbl.MouseClick = function(sender, args)
		ToggleShow()
		OptR3lbl:SetText( tostring( StartVisible ) );
	end
	OptR4lbl.MouseClick = function(sender, args)
		ToggleWEsc()
		OptR4lbl:SetText( tostring( HideWEsc ) );
	end
	OptR5lbl.MouseClick = function(sender, args)
		LockHugeBagSize()
		OptR5lbl:SetText( tostring( LockSize ) );
	end
	OptR6lbl.MouseClick = function(sender, args)
		LockHugeBagPosition()
		OptR6lbl:SetText( tostring( LockPosition ) );
	end
	OptR7lbl.MouseClick = function(sender, args)
		SlotsInfo()
	end
	OptR8lbl.MouseClick = function(sender, args)
		HelpInfo()
	end
	OptR9lbl.MouseClick = function(sender, args)
		ResetLSSettings()
		self:Close();
	end
	OptR10lbl.MouseClick = function(sender, args)
		ResetSettings()
		self:Close();
	end
	OptR11lbl.MouseClick = function(sender, args)
		ShowAbout()
	end
	OptR1lbl.MouseHover = function(sender, args)
		OptR1lbl:SetBackColor( lightgray )
		OptR1lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR1lbl.MouseLeave = function(sender, args)
		OptR1lbl:SetBackColor( black )
	end
	OptR2lbl.MouseHover = function(sender, args)
		OptR2lbl:SetBackColor( lightgray )
		OptR2lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR2lbl.MouseLeave = function(sender, args)
		OptR2lbl:SetBackColor( black )
	end
	OptR3lbl.MouseHover = function(sender, args)
		OptR3lbl:SetBackColor( lightgray )
		OptR3lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR3lbl.MouseLeave = function(sender, args)
		OptR3lbl:SetBackColor( black )
	end
	OptR4lbl.MouseHover = function(sender, args)
		OptR4lbl:SetBackColor( lightgray )
		OptR4lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR4lbl.MouseLeave = function(sender, args)
		OptR4lbl:SetBackColor( black )
	end
	OptR5lbl.MouseHover = function(sender, args)
		OptR5lbl:SetBackColor( lightgray )
		OptR5lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR5lbl.MouseLeave = function(sender, args)
		OptR5lbl:SetBackColor( black )
	end
	OptR6lbl.MouseHover = function(sender, args)
		OptR6lbl:SetBackColor( lightgray )
		OptR6lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR6lbl.MouseLeave = function(sender, args)
		OptR6lbl:SetBackColor( black )
	end
	OptR7lbl.MouseHover = function(sender, args)
		OptR7lbl:SetBackColor( lightgray )
		OptR7lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR7lbl.MouseLeave = function(sender, args)
		OptR7lbl:SetBackColor( black )
	end
	OptR8lbl.MouseHover = function(sender, args)
		OptR8lbl:SetBackColor( lightgray )
		OptR8lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR8lbl.MouseLeave = function(sender, args)
		OptR8lbl:SetBackColor( black )
	end
	OptR9lbl.MouseHover = function(sender, args)
		OptR9lbl:SetBackColor( lightgray )
		OptR9lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR9lbl.MouseLeave = function(sender, args)
		OptR9lbl:SetBackColor( black )
	end
	OptR10lbl.MouseHover = function(sender, args)
		OptR10lbl:SetBackColor( lightgray )
		OptR10lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR10lbl.MouseLeave = function(sender, args)
		OptR10lbl:SetBackColor( black )
	end
	OptR11lbl.MouseHover = function(sender, args)
		OptR11lbl:SetBackColor( lightgray )
		OptR11lbl:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
	end
	OptR11lbl.MouseLeave = function(sender, args)
		OptR11lbl:SetBackColor( black )
	end
	-- **^
	--**v Window event handlers v**
	-- **v Set the opacity when the mouse enter the window v**
	self.MouseEnter = function( sender, args )
		self:SetOpacity( 1.0 );
	end
	-- **^
	-- **v Set the opacity when the mouse leave the window v**
	self.MouseLeave = function( sender, args )
		self:SetOpacity( 1.0 );
	end
	-- **^
	--**^ Window event handlers ^**
	--**v Button event handlers v**
	-- **v Button click event v**
	buttonClose.Click = function(sender, args)
		self:Close();
	end
	-- **^
	--**^ Button event handlers ^**
	--^ EVENT HANDLERS SECTION ^--
end
-- **^
--v FUNCTIONS/METHODS SECTION v--
-- **v Load settings v**
function LoadSettings( sender )
	settings = {};
	settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagSettings" );
	
	-- **v no setting found, so save it v**
	if settings == nil then
		WinLocX = Turbine.UI.Display.GetWidth() - edgePadding - WinWidth
		WinLocY = Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55
		SaveSettings()
	end
	-- **^
	-- **v Load Settings v**
	WinLocX = settings.X;
	WinLocY = settings.Y;
	WinWidth = settings.Width;
	WinHeight = settings.Height;
	HideWEsc = settings.HideWEsc;
	StartVisible = settings.StartVisible;
	ShowSlotsInfo = settings.ShowSlotsInfo;
	ToggleUsed = settings.ToggleUsed;
	LockPosition = settings.LockPosition;
	LockSize = settings.LockSize;
	-- **^
	-- **v Check version so settings can be updated (if a user used an old version before the last release)
	if ( settings.Version ~= Version ) then
		local Updatedsettings = {};

		if settings.StartVisible == nil then
			Updatedsettings.StartVisible = true;
		else
			Updatedsettings.StartVisible = StartVisible;
		end
		if settings.ShowSlotsInfo == nil then
			Updatedsettings.ShowSlotsInfo = true;
		else
			Updatedsettings.ShowSlotsInfo = ShowSlotsInfo;
		end

		Updatedsettings.X = WinLocX;
		Updatedsettings.Y = WinLocY;
		Updatedsettings.Width = WinWidth;
		Updatedsettings.Height = WinHeight;

		if settings.HideWEsc == nil then
			Updatedsettings.HideWEsc = false;
		else
			Updatedsettings.HideWEsc = HideWEsc;
		end
		if settings.LockPosition == nil then
			Updatedsettings.LockPosition = false;
		else
			Updatedsettings.LockPosition = LockPosition;
		end
		if settings.LockSize == nil then
			Updatedsettings.LockSize = false;
		else
			Updatedsettings.LockSize = LockSize;
		end
		if settings.ToggleUsed == nil then
			Updatedsettings.ToggleUsed = false;
		else
			Updatedsettings.ToggleUsed = ToggleUsed;
		end

		Updatedsettings.Version = Version;
		Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagSettings", Updatedsettings );
	end
	-- **^
end
-- **^
-- **v Save settings v**
function SaveSettings()
	settings = {};
	settings.Version = Version;
	settings.X = WinLocX; --Turbine.UI.Display.GetWidth() - edgePadding - self:GetWidth()
	settings.Y = WinLocY; --Turbine.UI.Display.GetHeight() - edgePadding - self:GetHeight() - 55
	settings.Width = WinWidth; --frmMain:GetWidth();
	settings.Height = WinHeight; --frmMain:GetHeight();
	settings.StartVisible = StartVisible;
	settings.ShowSlotsInfo = ShowSlotsInfo;
	settings.ToggleUsed = ToggleUsed;
	settings.HideWEsc = HideWEsc;
	settings.LockPosition = LockPosition;
	settings.LockSize = LockSize;
	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagSettings", settings );
end
-- **^
-- **v Reset Location and Size Settings v**
function ResetLSSettings()
	WinWidth, WinHeight = 460, 300;
	frmMain:SetSize( WinWidth, WinHeight );
	frmMain:SetPosition( Turbine.UI.Display.GetWidth() - edgePadding - WinWidth, Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55 );
	WinLocX, WinLocY = frmMain:GetPosition()
	SaveSettings()
	frmMain:SetVisible( true );
	frmMain:PerformLayout()
	Turbine.Shell.WriteLine( "HugeBag: My location and size was set back to default" );
end
-- **^
-- **v Reset All Settings v**
function ResetSettings()
	StartVisible = true;
	ShowSlotsInfo = true;
	ToggleUsed = false;
	HideWEsc = false;
	LockPosition = false;
	LockSize = false;
	WinWidth, WinHeight = 460, 300;
	frmMain:SetSize( WinWidth, WinHeight );
	frmMain:SetPosition( Turbine.UI.Display.GetWidth() - edgePadding - WinWidth, Turbine.UI.Display.GetHeight() - edgePadding - WinHeight - 55 );
	WinLocX, WinLocY = frmMain:GetPosition()
	SaveSettings()
	frmMain:SetVisible( true );
	frmMain:PerformLayout()
	Turbine.Shell.WriteLine( "HugeBag: All my settings was set back to default" );
end
-- **^
--^ FUNCTIONS/METHODS SECTION ^--